<template lang="pug">
	Card(:muted="completed")
		div(:class="{ Task__completed: completed }").Task
			div.Task--text
				h5.Task--title {{ title }}
				span(v-if="description !== '' && description !== null").Task--description {{ description }}
			Checkbox-input(:checked="completed" :onchange="toggle_task").Task--toggle
			Icon-button(title="Edit task" type="ghost" name="more_vert" @click.native="open_edit_dialog")

		Dialog(title="Update task" :onclose="close_all_dialogs" :open="edit_dialog_open")
			template(slot="content")
				Field-input(placeholder="Title" v-model="new_title")
				Field-input(placeholder="Description" v-model="new_description")
			template(slot="actions")
				Button(title="Update task" @click.native="update_task" align="right") Update
				Button(title="Close" type="accent" @click.native="close_all_dialogs" align="right") Close
				Icon-button(title="Delete task" type="ghost" name="delete" @click.native="open_delete_dialog" align="right")

		Dialog(title="Delete task" :onclose="close_all_dialogs" :open="delete_dialog_open")
			template(slot="content")
				| Are you sure you want to delete: {{ title }}
			template(slot="actions")
				Button(title="Delete task" @click.native="delete_task" align="right") Delete
				Button(title="Close" type="accent" @click.native="close_all_dialogs" align="right") Close
</template>

<script lang="ts">
import Vue from 'vue';
import Card from '@/components/card.vue';
import Icon_button from '@/components/icon_button.vue';
import Button from '@/components/button';
import Checkbox_input from '@/components/checkbox_input.vue';
import Field_input from '@/components/field_input.vue';
import Dialog from '@/components/dialog';

export default Vue.extend({
	components: {
		Card,
		'Icon-button': Icon_button,
		'Button': Button,
		'Checkbox-input': Checkbox_input,
		'Field-input': Field_input,
		Dialog,
	},
	props: {
		id: {
			type: String,
			default: null,
			required: true,
		},
		title: {
			type: String,
			default: null,
			required: true,
		},
		description: {
			type: String,
			default: null,
			required: false,
		},
		completed: {
			type: Boolean,
			default: false,
			required: false,
		},
	},
	data() {
		return {
			edit_dialog_open: false,
			delete_dialog_open: false,
			new_title: this.title,
			new_description: this.description,
		};
	},
	methods: {
		open_edit_dialog() {
			this.edit_dialog_open   = true;
			this.delete_dialog_open = false;
		},
		open_delete_dialog() {
			this.delete_dialog_open = true;
			this.edit_dialog_open   = false;
		},
		close_all_dialogs() {
			this.delete_dialog_open = false;
			this.edit_dialog_open   = false;
		},
		update_task() {
			this.$store.dispatch('update_task', {
				id: this.id,
				title: this.new_title,
				description: this.new_description,
			});

			this.close_all_dialogs();
		},
		delete_task() {
			this.$store.dispatch('delete_task', {
				id: this.id,
			});

			this.close_all_dialogs();
		},
		toggle_task(completed: boolean) {
			this.$store.dispatch('toggle_task', {
				id: this.id,
				completed,
			});
		},
	},
});
</script>

<style lang="scss" scoped>
@import "@/assets/style/_colors.scss";

.Task {
	display: flex;
}

.Task__completed > .Task--text {
	text-decoration: line-through;
}

.Task--text {
	display: flex;
	flex: 1;
	margin: 0;
	flex-direction: column;
	justify-content: center;
}

.Task--title, .Task--description {
	display: flex;
	margin: 0;
}

.Task--toggle {
	display: flex;
	align-self: center;
	justify-self: end;
}
</style>
